<script lang="ts" setup>
import GitApiCall from '@/api/gitApi'
import ScheduleDeleteModal from '@/components/gitlab/ScheduleDeleteModal.vue'
import cronParser from 'cron-parser'
import { onMounted, ref, watch } from 'vue'
import { VDataTable, VPagination } from 'vuetify/components'

const props = defineProps({
  route: {
    type: String,
    default: 'vendors',
  },
  projectId: {
    type: Number,
    default: 0,
  },
})

const fields = ref([
  { key: 'description', label: 'Description' },
  { key: 'ref', label: 'Branch' },
  { key: 'cron', label: 'Next Execution', formatter: nextExecution },
  { key: 'cron_timezone', label: 'Timezone' },
  { key: 'created_at', label: 'Created', formatter: timeFormatter },
  { key: 'updated_at', label: 'Updated', formatter: timeFormatter },
  { key: 'Actions', label: 'Actions' },
])

const schedulesList = ref([])
const perPage = ref(20)
const pageOptions = ref([5, 10, 20, 50, 100])
const currentPage = ref(1)
const totalRows = ref(1)

watch([perPage, currentPage, () => props.projectId], () => {
  getSchedulesList()
})

onMounted(() => {
  console.debug('DEBUG: ScheduleTableComponent mounted')
  getSchedulesList()
})

async function getSchedulesList() {
  console.info('INFO: getSchedulesList projectId: ', props.projectId)
  if (props.projectId === 0) return

  const gitApi = new GitApiCall()
  try {
    const response = await gitApi.getSchedulesList(props.projectId, perPage.value, currentPage.value)
    totalRows.value = Number(response.headers['x-total'])
    schedulesList.value = response.data
  } catch (error) {
    console.error('getSchedulesList error: ', error)
  }
}

function finished() {
  getSchedulesList()
}

function timeFormatter(value) {
  const date = new Date(value)
  return `${date.toLocaleDateString()} ${date.toLocaleTimeString()}`
}

function nextExecution(cronExpression) {
  const options = { currentDate: new Date() }
  const interval = cronParser.parseExpression(cronExpression, options)
  const nextExecution = new Date(interval.next().toString())
  const now = new Date()
  const diff = nextExecution - now

  const timeUnits = [
    { unit: 'day', duration: 1000 * 60 * 60 * 24 },
    { unit: 'hour', duration: 1000 * 60 * 60 },
    { unit: 'minute', duration: 1000 * 60 },
    { unit: 'second', duration: 1000 },
  ]

  let remainingTime = diff
  for (let i = 0; i < timeUnits.length - 1; i++) {
    const timeUnit = timeUnits[i]
    const timeValue = Math.floor(remainingTime / timeUnit.duration)
    if (timeValue > 0) {
      remainingTime -= timeValue * timeUnit.duration
      const nextTimeUnit = timeUnits[i + 1]
      const nextTimeValue = Math.floor(remainingTime / nextTimeUnit.duration)
      return `In ${timeValue} ${timeUnit.unit}${timeValue > 1 ? 's' : ''} and ${nextTimeValue} ${nextTimeUnit.unit}${nextTimeValue > 1 ? 's' : ''}`
    }
  }
  return 'Less than 1 minute'
}
</script>

<template>
  <v-data-table
    :items="schedulesList"
    :headers="fields"
    :items-per-page="perPage"
    :page.sync="currentPage"
    :server-items-length="totalRows"
    item-value="id"
    class="elevation-1"
  >
    <template v-slot:[`item.cron`]="{ item }">
      {{ nextExecution(item.cron) }}
    </template>
    <template v-slot:[`item.created_at`]="{ item }">
      {{ timeFormatter(item.created_at) }}
    </template>
    <template v-slot:[`item.updated_at`]="{ item }">
      {{ timeFormatter(item.updated_at) }}
    </template>
    <template v-slot:[`item.Actions`]="{ item }">
      <schedule-delete-modal :schedule="item" @finished="finished" />
    </template>
  </v-data-table>
  <v-pagination
    v-model:page="currentPage"
    :length="Math.ceil(totalRows / perPage)"
    :total-visible="7"
    @input="getSchedulesList"
  />
</template>

<style scoped>
/* Agrega aquí tus estilos personalizados */
</style>
